{****************************************************************************
 * SoundLib 2 soundcard info - copyright (c) 2001 by Stefan Goehler         *
 * Copyright agreement in soundlib.txt - illegal copy without this file!    *
 * Any bug reports and suggestions are welcome                              *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}
uses sndlib2,drv_sb,crt;

var
  sb    : psoundblaster;
  cap   : tcardinfo;
  i,val : integer;


function hexstr(l : longint;width : word) : string;
{ Get from longint value hex-string }
const
  hexs : array[0..15] of char=
  ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
var
  s : string[10];
  i : longint;
begin
  s := '';
  for i := 0 to width-1 do
  begin
    s := hexs[l and 15]+s;
    l := l shr 4;
  end;
  hexstr := s;
end;

begin
  { Try to initialize soundcard }
  new(sb,init(0));
  if (sb = nil) then
  begin
    writeln('Sorry, no SB compatible card found');
    halt;
  end;

  { Put out information }
  textmode(3+font8x8);
  sb^.getcapabilities(cap);
  writeln(sl_versionstr+' detected card parameters');
  writeln;
  writeln('Detected card   : ',cap.cardstring);
  writeln('Hardware version: '+hexstr(cap.version,4)+'h');
  writeln('Used driver     : ',cap.driverstring);
  writeln;
  writeln('Card does support: ');
  if (cap.flags and snd_16bit <> 0) then
  writeln('- 8 bits and 16 bits resolution')
  else writeln('- 8 bits resolution');
  writeln('- Mono playback at ',cap.minfreq,'..',cap.monoplay.max,' Hz');
  if (cap.flags and snd_stereo <> 0) then
  writeln('- Stereo playback at ',cap.minfreq,'..',cap.stereoplay.max,' Hz');
  writeln;
  writeln;
  writeln('Current output mixer values:');
  writeln;

  { Check number of output controls }
  if (sb^.getnumofoutcontrols = 0) then
    writeln(' No output control available')
  else
  { Show content of all output settings }
  begin
    writeln('Constant           Name   Value(l)   Value(r)');
    for i := 0 to sb^.getnumofoutcontrols-1 do
    begin
      val := sb^.getoutcontroltype(i);
      write(val:8);
      write(sb^.getoutcontrolname(val):15);
      write(sb^.getoutcontrol(val+cnt_left):11);
      write(sb^.getoutcontrol(val+cnt_right):11);
      writeln;
    end;
  end;

  writeln;
  writeln;
  writeln('Press any key to exit...');
  readkey;
  sb^.free;
  textmode(3);
end.